/** fMSX: portable MSX emulator ******************************/
/**                                                         **/
/**          AnyX.h (previously named Unix.h)               **/
/**                                                         **/
/** This file contains  Common definitons and declarations  **/
/** for AnyX.c, Colors.c and Refresh.c, which in turn       **/
/** contain the improved  Unix/X-dependent subroutines and  **/
/** drivers.                                                **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin  1994,1995                **/
/**               Arnold Metselaar 1998-1999                **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify us, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

/* size of ximage (fixed) */
#define WIDTH 512
#define HEIGHT 424

#define LINES (ScanLines212?212:192)

#include <X11/Xlib.h>
#include "MSX.h"

/** Some typedef's **/
typedef union {
  XID ct_xid;
  long ct_long;
  word ct_word;
  byte ct_byte;
  byte ct_Byte[4]; 
} ColTyp; /* sizeof ColTyp should be 4 */


typedef struct
{
  void (*Take)(int ColSet);
  void (*Leave)(int ColSet);
  void (*TakeScr8)(void);
  void (*LeaveScr8)(void);
  void (*Refresh)(void);
  ColTyp (*GetCol2p)(byte * pal2p); 
} Colorinterface;

/* In Colors.c */
int InitColor(int, int, Colormap*);
void TrashColor(void);
ColTyp Swap(XID X);
XID UnSwap(ColTyp X);

extern Colorinterface Colors;
extern ColTyp XPal[16],XPal8[256];
extern XID white,black;
extern int PalUsed, PalOut, Used8 , IsPal8; 

/* In Unix.c */
extern Display *Dsp;
extern void BorderChange(int y, ColTyp c0, ColTyp c1, int width, int offset);
extern int Mapped, StdSprites;
extern byte *XBuf;
extern int high,wide;
extern int bitpix; /* number of bits per pixel in the X-image */
extern int ChooseFormat(); /* find out bitpix for the visual */

/* In Refresh.c */
extern int NSprMax_M, NSprMax_C;
extern void choosefuncs(int lsbfirst, int bitpix);
extern void setwidth(int wide);
extern const byte SprCol8[16];
extern Bool lsbfirst;
extern int eo_flag;

